#!/usr/bin/env python
# vim:encoding=cp936

import urllib2
from DownloadDlg import *
import threading
import wx
_ = wx.GetTranslation

class DownloadThread(threading.Thread):
    ''' Thread used for downloading. '''

    def __init__(self, view, input, output, size):
        threading.Thread.__init__(self)

        self.__view = view
        self.__input = input
        self.__output = output
        self.__size = size

    def run(self):
        try:
            size = 0
            block = ""

            while (size < self.__size and not self.__view.IsCanceled()):
                block = self.__input.read(4096)
                if block == 0:
                    break
                size += len(block)
                self.__output.write(block)
                self.__view.SetValue(100 * size / self.__size)
        except:
            self.__view.Cancel()
            self.__view.SetValue(self.__i)
            wx.MessageBox(_("Downloading failed."), _("TrueIce Download"),
                wx.ICON_ERROR);
                                                                                
def PlayURLToDownloadURL(playurl):
    ''' Download the m3u playlist and read the actual URL of the audio file
        from the playlist. '''
    f = None
    content = ""
    try:
        f = urllib2.urlopen(playurl)
        line = f.readline()
        while len(line) != 0 and (line.strip(" \t\r\n") == ""
            or line.strip(" \t\r\n")[0] == '#'):
            line = f.readline()
        content = line.strip(" \t\r\n")
    except:
        if f != None:
            f.close()
    return content
                                                                                
def DownloadFromTrueIce(parent, playurl, saveto):
    ''' Download the audio file which the online playing URL referes to the
        local file. '''
    downloadurl = PlayURLToDownloadURL(playurl)
    if not downloadurl.startswith("http://"):
        wx.MessageBox(_("Invalid play URL."), _("TrueIce Download"),
            wx.ICON_ERROR)
        return False

    input = None
    output = None

    try:
        input = urllib2.urlopen(downloadurl)
        size = int(input.info()["Content-Length"])
    except:
        if input != None:
            input.close()
        wx.MessageBox(_("Error opening the specified URL."),
            _("TrueIce Download"), wx.ICON_ERROR);

    try:
        output = file(saveto, 'w')
    except:
        input.close()
        if output != None:
            input.close()
        wx.MessageBox(_("Error opening output file."),
            _("TrueIce Download"), wx.ICON_ERROR);
        return False

    dialog = DownloadDlg(parent)

    downthread = DownloadThread(dialog, input, output, size)
    downthread.start()

    dialog.CentreOnParent()
    dialog.ShowModal()

    dialog.Destroy()

    input.close()
    output.close()

    return True
