#!/usr/bin/env python
# vim:encoding=cp936
#--------------------------------------------------------------------------
# Name:         DownloadDlg.py
# Author:       XXXX
# Created:      XX/XX/XX
# Copyright:    
#--------------------------------------------------------------------------

import wx
from TrueIceDown_wdr import *
_ = wx.GetTranslation

# WDR: classes

class DownloadDlg(wx.Dialog):
    ''' A simple dialog with a progress bar. '''

    def __init__(self, parent, id = -1):
        wx.Dialog.__init__(self, parent, id, _("Downloading"),
            style = wx.DEFAULT_DIALOG_STYLE)
        
        # WDR: dialog function RWInputDlgFunc for DownloadDlg
        ProgressDlgFunc(self, True)
        
        # WDR: handler declarations for DownloadDlg
        wx.EVT_BUTTON(self, wx.ID_CANCEL, self.OnCancel)
        wx.EVT_TIMER(self, 0, self.OnUpdate)

        self.SetIcons(TrueIceDownIconsFunc(IDC_TID_ICON))

        # Binding controls to variables
        self.__m_Gauge      = self.FindWindowById(ID_GAUGE)

        # Initializing local variables
        self.__value = 0
        self.__destroy = False
        self.__destroyed = False

        # Initializing controls

    # WDR: methods for DownloadDlg

    def SetValue(self, value):
        ''' Modify the value of the progress bar, in percentage.

            The dialog will be destroyed if the value is 100. '''
        if self.__destroyed:
            return

        if value < 0:
            value = 0
        elif value > 100:
            value = 100

        self.__value = value
        self.AddPendingEvent(wx.TimerEvent())

    def IsCanceled(self):
        ''' Check whether the "Cancel" button has been clicked. '''
        return self.__destroy

    def Cancel(self):
        ''' Destroy the dialog box.

            You should not call "Destroy()" directly in other thread. '''
        self.__destroy = True
        self.AddPendingEvent(wx.TimerEvent())

    # WDR: handler implementations for DownloadDlg

    def OnCancel(self, event):
        self.__destroy = True

    def OnUpdate(self, event):
        if self.__destroyed:
            return

        self.__m_Gauge.SetValue(self.__value)
        if self.__value == 100 or self.__destroy:
            self.__destroyed = True
            self.EndModal(wx.ID_CANCEL)
