#!/usr/bin/env python
# vim:encoding=cp936
#----------------------------------------------------------------------------
# Name:         TrueIceDownDlg.py
# Author:       XXXX
# Created:      XX/XX/XX
# Copyright:    
#----------------------------------------------------------------------------

import wx
from Download import *
from TrueIceDown_wdr import *
_ = wx.GetTranslation

# WDR: classes

class TrueIceDownDlg(wx.Dialog):
    ''' Main dialog box. '''

    def __init__(self, parent, id = -1, url = ""):
        wx.Dialog.__init__(self, parent, id, _("TrueIce Download"),
            style = wx.DEFAULT_DIALOG_STYLE)
        
        # WDR: dialog function RWInputDlgFunc for TrueIceDownDlg
        TrueIceDownDlgFunc(self, True)
        
        # WDR: handler declarations for TrueIceDownDlg
        wx.EVT_BUTTON(self, wx.ID_OK, self.OnOK)
        wx.EVT_TEXT(self, ID_EDIT_SAVE_TO, self.OnEditSaveToChange)
        wx.EVT_TEXT(self, ID_EDIT_URL, self.OnEditURLChange)
        wx.EVT_BUTTON(self, ID_BTN_BROWSE, self.OnBrowse)

        self.SetIcons(TrueIceDownIconsFunc(IDC_TID_ICON))

        # Binding controls to variables
        self.__m_EditURL    = self.FindWindowById(ID_EDIT_URL)
        self.__m_EditSaveTo = self.FindWindowById(ID_EDIT_SAVE_TO)
        self.__m_BtnOK      = self.FindWindowById(wx.ID_OK)

        # Initializing local variables
        self.__defaultDir = ""

        # Initializing controls
        self.CheckValue()
        self.__m_EditURL.SetValue(url)

    # WDR: methods for TrueIceDownDlg

    def CheckValue(self):
        ''' Check wether input values are valid.

            Enable the "OK" button if all values are valid. '''
        self.__m_BtnOK.Enable(self.__m_EditSaveTo.GetValue() != ""
            and self.__m_EditURL.GetValue().startswith(
            "http://"))

    # WDR: handler implementations for TrueIceDownDlg

    def OnOK(self, event):
        DownloadFromTrueIce(self, self.__m_EditURL.GetValue(),
            self.__m_EditSaveTo.GetValue())

    def OnEditSaveToChange(self, event):
        self.CheckValue()

    def OnEditURLChange(self, event):
        self.CheckValue()

    def OnBrowse(self, event):
        dlg = wx.FileDialog(self, _("Save as"), self.__defaultDir,
            style = wx.SAVE | wx.OVERWRITE_PROMPT,
            wildcard = \
                _("MP3 files") + " (*.mp3)|*.mp3|"
                + _("WMA files") + " (*.wma)|*.wma|"
                + _("All files") + " (*.*)|*")

        if dlg.ShowModal() == wx.ID_OK:
            self.__m_EditSaveTo.SetValue(dlg.GetPath())
            self.__defaultDir = dlg.GetDirectory()
            self.CheckValue()
